<template>
  <div class="statistic-chart">
    <div class="text-2xl text-primary font-semibold py-2 px-4">
      สถิติการใช้ไฟฟ้า
    </div>

    <div style="height: calc(100% - 48px)">
      <canvas id="chart"></canvas>
    </div>
  </div>
</template>

<script>
import Chart from "chart.js/auto";
import ChartDataLabels from "chartjs-plugin-datalabels";
import _ from "lodash";
import numeral from "numeral";

export default {
  props: {
    chart_data: {
      type: Array,
      default: () => {
        return [];
      },
    },
    selected_table_item: {
      type: Object,
      default: () => {
        return {};
      },
    },
    selectTableItem: {
      type: Function,
      default: () => {
        return {};
      },
    },
  },
  data() {
    return {
      chart: null,
    };
  },
  watch: {
    selected_table_item(newValue, oldValue) {
      this.updateChart();
    },
  },
  mounted() {
    this.setChart();
  },
  methods: {
    updateChart() {
      const dataset = this.chart.data.datasets[1];
      dataset.backgroundColor = [];

      _.forEach(dataset.data, (d, index) => {
        if (this.selected_table_item.id === index + 1) {
          dataset.backgroundColor[index] = "#00D1E3";
        } else {
          dataset.backgroundColor[index] = "#FF9C40";
        }
      });

      this.chart.update();
    },
    setChart() {
      const ctx = document.getElementById("chart");

      const options = {
        maintainAspectRatio: false,
        layout: {
          padding: {
            top: 24,
            bottom: 12,
            right: 40,
          },
        },
        plugins: {
          tooltip: {
            enabled: false,
          },
          legend: {
            position: "left",
            labels: {
              boxWidth: 20,
              boxHeight: 20,
            },
          },
        },
        scales: {
          y: {
            ticks: {
              display: false,
            },
            grid: {
              color: function (context) {
                return context.tick.value === 0 ? "white" : "transparent";
              },
              drawBorder: false,
            },
          },
          x: {
            grid: {
              display: false,
            },
          },
        },
        onClick: (e, elements, chart) => {
          if (elements.length === 0) return;
          const id = elements[0].index + 1;
          const item = _.find(this.chart_data, (d) => d.id === id);
          this.selectTableItem(item);
        },
      };

      const config = {
        data: {
          datasets: [
            {
              type: "line",
              label: "หน่วยไฟฟ้า (kWh)",
              data: _.map(this.chart_data, (d) => d.unit),
              borderColor: "#00D1E3",
              backgroundColor: "#00D1E3",
              datalabels: {
                anchor: "end",
                align: "end",
                formatter: function (value) {
                  return numeral(value).format("0,0");
                },
                font: {
                  size: 12,
                },
              },
            },
            {
              type: "bar",
              label: "ค่าไฟฟ้า (บาท)",
              data: _.map(this.chart_data, (d) => d.price),
              backgroundColor: "#FF9C40",
              barPercentage: 0.6,
              datalabels: {
                anchor: "end",
                align: "end",
                formatter: function (value) {
                  return numeral(value).format("0,0");
                },
                font: {
                  size: 12,
                },
              },
            },
          ],
          labels: _.map(this.chart_data, (d) => d.month_abb),
        },
        options,
        plugins: [ChartDataLabels],
      };

      Chart.defaults.font.family = "Kanit";
      Chart.defaults.font.size = 12;
      Chart.defaults.color = "white";
      Chart.defaults.font.weight = 300;
      this.chart = new Chart(ctx, config);
    },
  },
};
</script>

<style lang="scss" scoped></style>
